include \masm32\include\masm32rt.inc ;\asm\win32.inc

jeaxz macro lbl:REQ
 test eax,eax
 jz lbl
endm

jeaxnz macro lbl:REQ
 test eax,eax
 jnz lbl
endm

.data?
frmhfont DWORD ?
hinst    DWORD ?
hstatic01 dd ?
hbutton01 dd ?
hbutton02 dd ?
redbrush  dd ?
greenbrush  dd ?
toggle dd ?

.const
frmtitle BYTE 'Form1',0
frmclass BYTE 'Class1',0
frmnfont BYTE 'Tahoma',0
static   db 'static',0
button db 'button',0
static01text db 'static01',0
b1 db 'Red',0
b2 db 'Green',0

.code

frmproc proc public uses ebx hwnd:DWORD,msg:DWORD,wparam:DWORD,lparam:DWORD
    mov eax,msg
    mov ecx,wparam
    mov edx,lparam

    cmp eax,WM_CREATE
    jnz over0
    sub eax,eax
    INVOKE CreateFont,-11,eax,eax,eax,eax,eax,eax,eax,eax,\
                      eax,eax,eax,eax,OFFSET frmnfont
    mov frmhfont,eax
    INVOKE SendMessage,hwnd,WM_SETFONT,eax,1

    invoke CreateSolidBrush,000000ffh
    mov redbrush,eax
    invoke CreateSolidBrush,0000ff00h
    mov greenbrush,eax

    invoke CreateWindowEx,0,offset static,offset static01text,WS_VISIBLE+WS_CHILD+SS_LEFT,08,08,70,16,hwnd,01,hinst,0
    mov hstatic01,eax
    INVOKE SendMessage,eax,WM_SETFONT,frmhfont,1
    
    invoke CreateWindowEx,0,offset button,offset b1,WS_VISIBLE+WS_CHILD,08,32,64,24,hwnd,11,hinst,0
    mov hbutton01,eax
    INVOKE SendMessage,eax,WM_SETFONT,frmhfont,1
    
    invoke CreateWindowEx,0,offset button,offset b2,WS_VISIBLE+WS_CHILD,80,32,64,24,hwnd,12,hinst,0
    mov hbutton02,eax
    INVOKE SendMessage,eax,WM_SETFONT,frmhfont,1
    
    sub eax,eax
    jmp done

  over0:
    cmp eax,WM_CLOSE
    jnz over1
    INVOKE PostQuitMessage,0
    sub eax,eax
    jmp done

  over1:
    cmp eax,WM_DESTROY
    jnz over2
    INVOKE DeleteObject,frmhfont
    INVOKE DeleteObject,redbrush
    INVOKE DeleteObject,greenbrush
    jmp def

  over2:
    cmp eax,WM_CTLCOLORSTATIC
    jnz over3
    cmp toggle,0
    jnz @f
    invoke SetBkColor,ecx,000000ffh
    mov eax,redbrush
    jmp done
    @@:
    invoke SetBkColor,ecx,0000ff00h
    mov eax,greenbrush
    jmp done

  over3:
    cmp eax,WM_COMMAND
    jnz over4
    movzx eax,cx    ;loword(wparam)=id
    shr ecx,16      ;hiword(wparam)=notification
    cmp ecx,BN_CLICKED
    jnz def
    sub eax,11
    mov toggle,eax
    invoke InvalidateRect,hstatic01,0,1
    sub eax,eax
    jmp done

  over4:
  def:
    INVOKE DefWindowProc,hwnd,msg,wparam,lparam
  done:
    ret

frmproc endp

start proc public
    local m:MSG
    sub ebx,ebx

    push ebx
    call GetModuleHandle
    mov hinst,eax

    push ebx                ;hIconSm
    push OFFSET frmclass    ;lpszClassName
    push ebx                ;lpszMenuName
    push COLOR_WINDOW+1     ;hbrBackground
    push 32512
    push ebx
    call LoadCursor
    push eax                ;hCursor
    push 32512
    push ebx
    call LoadIcon
    push eax                ;hIcon
    push hinst              ;hInstance
    push ebx                ;cbWndExtra
    push ebx                ;cbClsExtra
    push OFFSET frmproc     ;lpfnWndProc
    push 3                  ;style
    push 48                 ;cbSize
    push esp
    call RegisterClassEx
    add esp,48
    jeaxz done

    push ebx                ;lpParam
    push hinst              ;hInstance
    push ebx                ;hMenu
    push ebx                ;hwndParent
    push 100                ;nHeight
    push 200                ;nWidth
    push ebx                ;Y
    push ebx                ;X
    push (WS_VISIBLE or WS_BORDER or WS_CAPTION or \
          WS_MINIMIZEBOX or WS_CLIPCHILDREN or WS_SYSMENU)
    push OFFSET frmtitle    ;lpWindowName
    push OFFSET frmclass    ;lpClassName
    push ebx                ;dwExStyle
    call CreateWindowEx
    jeaxz done

    lea esi,m
  next:
    INVOKE GetMessage,esi,ebx,ebx,ebx
    jeaxz done
    INVOKE TranslateMessage,esi
    INVOKE DispatchMessage,esi
    jmp next
  done:
    push eax
    jmp ExitProcess
start ENDP
end start
